???File Path
==========
***...\Models\account\PaidchequeModels.cs


// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
// @@@@@@@@@@@@@@@  PaidChequeReturn  @@@@@@@@@@@@@@@
// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
public class MdlPaidChequeReturn {

	public long binPaidChequeReturnId { get; set; } = 0;
	
	[Required()]
	[Display(Name = "Documents")]
	public long binDocumentsId { get; set; } = 0;
	[Required()]
	[Display(Name = "Paid Cheque")]
	public long binPaidChequeId { get; set; } = 0;
	[Required()]
	[Display(Name = "Paid Cheque Details")]
	public long binPaidChequeDetailsId { get; set; } = 0;
	
	public long? binBankChargeId { get; set; } = null;
	public long? binBankCrCustomerId { get; set; } = null;
	public long? binBankExpenseId { get; set; } = null;
	
	[StringLength(3)]
	public string strBankCurrency { get; set; } = "";
	public double dblBankCurRoe { get; set; } = 1.00;
	public double dblBankCurBankCharge { get; set; } = 0.0;
	
	[StringLength(3)]
	public string strCustCurrency { get; set; } = "";
	public double dblCustCurRoe { get; set; } = 1.00;
	public double dblCustCurCustCharge { get; set; } = 0.0;
	
	[StringLength(3)]
	public string strBaseCurrency { get; set; } = "";
	public double dblBaseCurBankCharge { get; set; } = 0.0;
	public double dblBaseCurCustCharge { get; set; } = 0.0;
	
	public long? binServiceTaxId { get; set; } = null;
	public double dblSysPerceOfTax { get; set; } = 0.0;
	public double dblPerceOfTax { get; set; } = 0.0;
	public double dblLedgCurTaxBaseAmount { get; set; } = 0.0;
	public double dblLedgCurTaxAmount { get; set; } = 0.0;
	
	public double dblBaseCurTaxBaseAmount { get; set; } = 0.0;
	public double dblBaseCurTaxAmount { get; set; } = 0.0;
	
}

public class MdlReqPaidChequeReturn : MdlRequest {

	public MdlPaidChequeReturn mdlPaidChequeReturn { get; set; } = new MdlPaidChequeReturn();
}

public class MdlResPaidChequeReturn : MdlResponse {

	public MdlPaidChequeReturn mdlPaidChequeReturn { get; set; } = new MdlPaidChequeReturn();
}

public class MdlResPaidChequeReturnList : MdlResponse {

	public List<MdlPaidChequeReturn> lstMdlPaidChequeReturn { get; set; } = new List<MdlPaidChequeReturn>();
}

public class MdlResPaidChequeReturnInit : MdlResponse {
	public List<MdlBaseIntId> lstMdlDocumentsBaseIntId { get; set; } = new List<MdlBaseIntId>();
	public List<MdlBaseIntId> lstMdlPaidChequeBaseIntId { get; set; } = new List<MdlBaseIntId>();
	public List<MdlBaseIntId> lstMdlPaidChequeDetailsBaseIntId { get; set; } = new List<MdlBaseIntId>();
	public List<MdlBaseIntId> lstMdlBankChargeBaseIntId { get; set; } = new List<MdlBaseIntId>();
	public List<MdlBaseIntId> lstMdlBankCrCustomerBaseIntId { get; set; } = new List<MdlBaseIntId>();
	public List<MdlBaseIntId> lstMdlBankExpenseBaseIntId { get; set; } = new List<MdlBaseIntId>();
	public List<MdlBaseIntId> lstMdlServiceTaxBaseIntId { get; set; } = new List<MdlBaseIntId>();


	public List<MdlPaidChequeReturn> lstMdlPaidChequeReturn { get; set; } = new List<MdlPaidChequeReturn>();
}

